
varying vec3 P;//ʒuxNg
varying vec3 N;//@xNg
uniform sampler2D uSampler;

void main(void)
{
	vec3 L;
	vec4 textureColor = texture2D(uSampler, gl_TexCoord[0]);
	if(gl_LightSource[0].position.w == 0 ) L = normalize(gl_LightSource[0].position.xyz);   //s
	else  L = normalize(gl_LightSource[0].position.xyz  - P );                              //_
	N = normalize(N);
	
	vec4 ambient = gl_FrontLightProduct[0].ambient;
	float dotNL = dot(N, L);
	vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(0.0, dotNL);
	vec3 V = normalize(-P);
	vec3 H = normalize(L + V);
	float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);
	if(dotNL <= 0.0) powNH = 0.0;
	vec4 specular = gl_FrontLightProduct[0].specular * powNH;

	float d = distance(P, gl_LightSource[0].position.xyz);
	float attenuation; //_{X|bgCgɑ΂錸
	if(gl_LightSource[0].position.w > 0 ) attenuation = 1.0/(gl_LightSource[0].constantAttenuation + gl_LightSource[0].linearAttenuation*d + gl_LightSource[0].quadraticAttenuation*d*d);//W
	else attenuation = 1.0;

	//gl_FragColor = gl_FrontMaterial.emission + (ambient + diffuse + specular) * attenuation;
	
	vec4 lightWeighting = gl_LightSource[0].ambient + gl_LightSource[0].diffuse * max(dotNL, 0.0);
	gl_FragColor = vec4(textureColor.rgb * lightWeighting.rgb, textureColor.a) + specular;

	
}